import unittest
from rayon.data import Column, ConstantColumn


def dedent(bigstring):
    sio = StringIO(bigstring)
    return "".join(line.lstrip()[1:] for line in sio)


class t_Column(unittest.TestCase): 

    def test_1(self):
        c = Column((1, 2, 3))
        self.assertEqual(c[0], 1)

    def test_eq_1(self):
        self.assertEqual(Column((1, 2, 3)), Column((1, 2, 3)))

    def test_eq_2(self):
        self.assertNotEqual(Column((1, 2, 3)), Column((4, 5, 6)))

    def test_eq_2(self):
        self.assertNotEqual(Column((1, 2, 3)), Column(('a', 'b', 'c')))

    def test_add_1(self):
        self.assertEqual(Column((1, 2, 3)) + Column((4, 5, 6)),
                         Column((1, 2, 3, 4, 5, 6)))

    def test_add_2(self):
        self.assertEqual(Column((1, 2, 3)) + Column((4, 5)),
                         Column((1, 2, 3, 4, 5)))

    def test_add_3(self):
        self.assertRaises(
            TypeError,
            lambda: Column((1, 2, 3)) + Column(('a', 'b', 'c')))

        
class t_ConstantColumn(unittest.TestCase):
    def test_1(self):
        cc = ConstantColumn('a', 10)
        self.assertEqual(tuple(cc), ('a',) * 10)

    def test_add_1(self):
        self.assertRaises(
            TypeError,
            lambda: ConstantColumn('a', 2) + ConstantColumn('b', 2))
            
    def test_add_2(self):
        self.assertRaises(
            TypeError,
            lambda: ConstantColumn('a', 2) + Column(('b', 'b')))
            
    def test_add_2(self):
        self.assertRaises(
            TypeError,
            lambda: Column(('b', 'b')) + ConstantColumn('a', 2))
            

if __name__ == '__main__':
    unittest.main()
