from rayon.scales import (
    TimeBinnedScale,
    TimeScale, 
    RayonScaleException,
)
from netsa.data.times import make_datetime, make_timedelta
import unittest



times = [make_datetime("2000/01/01") + make_timedelta("PT%dS" % x)
         for x in [1,2,3]]
    

class t_TimeScale(unittest.TestCase):
    def test_attach_1(self):
        s = TimeScale()
        s.attach(times, None)
        self.assertEqual(times[0], s.get_input_min())
        self.assertEqual(times[-1], s.get_input_max())
            
    def test_attach_checks_input_1(self):
        s = TimeScale()
        self.assertRaises(RayonScaleException,
                          lambda: s.attach(["1", "2", "3"], None))


class t_TimeBinnedScale(unittest.TestCase):
    def test_attach_1(self):
        s = TimeBinnedScale(make_timedelta("PT1S"))
        s.attach(times, None)
        self.assertEqual(times[0], s.get_input_min())
        self.assertEqual(times[-1], s.get_input_max())
            
    def test_attach_checks_input_1(self):
        s = TimeBinnedScale(make_timedelta("PT1S"))
        self.assertRaises(RayonScaleException,
                          lambda: s.attach(["1", "2", "3"], None))
